%include "src/asm_io.inc"

section .data
    prompt_name db "Enter your name: ", 0
    prompt_num db "Enter a number (50-100): ", 0
    error_msg db "Error: Number must be 50-100.", 10, 0
    welcome_msg db "Welcome, ", 0
    newline db 10, 0
    prompt_start db "Enter start index (1-100): ", 0
    prompt_end db "Enter end index (1-100): ", 0
    range_error db "Invalid range.", 10, 0
    sum_msg db "Sum of range: ", 0

section .bss
    user_name resb 50    ; Buffer for user name
    user_num resd 1
    array resd 100
    start_index resd 1
    end_index resd 1
    range_sum resd 1

section .text
    global main

main:
    ; Prompt for and read user name
    mov eax, prompt_name
    call print_string
    call read_name

    ; Get user number
    mov eax, prompt_num
    call print_string
    call read_int
    mov [user_num], eax
    cmp eax, 50
    jl show_error
    cmp eax, 100
    jg show_error

    ; Print welcome message
    mov ecx, eax
welcome_loop:
    mov eax, welcome_msg
    call print_string
    mov eax, user_name
    call print_string
    call print_nl
    loop welcome_loop
    jmp fill_array

show_error:
    mov eax, error_msg
    call print_string
    call print_nl
    ret

fill_array:
    mov ecx, 100
    xor edi, edi
fill_loop:
    mov eax, edi
    inc eax
    mov [array + edi * 4], eax
    inc edi
    loop fill_loop
    call sum_range

sum_range:
    mov eax, prompt_start
    call print_string
    call read_int
    mov [start_index], eax
    mov eax, prompt_end
    call print_string
    call read_int
    mov [end_index], eax

    ; Validate range
    mov eax, [start_index]
    cmp eax, 1
    jl invalid_range
    cmp eax, 100
    jg invalid_range
    mov ebx, [end_index]
    cmp ebx, 1
    jl invalid_range
    cmp ebx, 100
    jg invalid_range
    cmp eax, ebx
    jg invalid_range

    ; Sum range
    xor ecx, ecx
    mov edi, eax
sum_loop:
    add ecx, [array + (edi - 1) * 4]
    inc edi
    cmp edi, ebx
    jg display_sum
    jmp sum_loop

display_sum:
    mov [range_sum], ecx
    mov eax, sum_msg
    call print_string
    mov eax, [range_sum]
    call print_int
    call print_nl
    ret

invalid_range:
    mov eax, range_error
    call print_string
    call print_nl
    ret

; Reads a name character-by-character and stores it in user_name
read_name:
    mov edi, user_name      ; Point to user_name buffer
read_char_loop:
    call read_char          ; Read one character
    cmp al, 10              ; Check for Enter key (newline)
    je end_read_name        ; If Enter, finish
    mov [edi], al           ; Store the character in the buffer
    inc edi                 ; Move to the next position
    cmp edi, user_name + 50 ; Ensure we don't exceed the buffer
    jne read_char_loop      ; Repeat until buffer is full or Enter is pressed

end_read_name:
    mov byte [edi], 0       ; Null-terminate the string
    ret
